
var Q = require("q/util");
var Queue = require("q/queue").Queue;
var retry = require("q/retry").retry;
var forwarder = require("q/forwarder").forwarder;

function Server(connect) {
};

exports.Client = Client;
function Client(connect, retryOptions) {
    var closed = Q.defer();
    var to = forwarder();
    var connection = to.promise;

    reconnect();

    function reconnect() {
        to.attach(retry(connect, retryOptions));
        Q.when(connection, function (connection) {
            console.log('when', connection);
            // resume any loops suspended on the connection
            // if the connection fails again, try to reconnect
            Q.when(connection.closed, reconnect);
        }, function (reason) {
            // upon failing to connect, close the queues
            // then close self
            closed.resolve(reason);
        });
    }

    function get() {
        return Q.post(connection, 'get');
    }

    function put(message) {
        return Q.post(connection, 'put', message);
    }

    function close(reason) {
        connection.close();
        return closed.promise;
    }

    return {
        "get": get,
        "put": put,
        "close": close,
        "closed": closed.promise
    }
};

